;; $Id: dbdivis.dsl 0.1 1997/07/31 14:51:33 nwalsh Exp $

;; ============================= DIVISIONS ==============================

(define ($divtitlepage$)
  (make element gi: "DIV"
	attributes: (list
		     (list "CLASS" (gi)))
	(process-children-trim)))

(element (SET TITLE) ($divtitlepage$))

(element BOOK 
  ;; Handle two cases:
  ;;   If there's a BOOKINFO, just process children.  BOOKINFO will handle
  ;;      generation of a title page and/or a TOC (see dbttlpg.dsl and 
  ;;      dbinfo.dsl)
  ;;   If there's no BOOKINFO, generate a simple page sequence containing
  ;;      the TOC, if a TOC is desired
  (let* ((btitle (select-elements (children (current-node)) "TITLE"))
	 (binfo  (select-elements (children (current-node)) "BOOKINFO"))
	 (title  (if (node-list-empty? btitle)
		     (select-elements (children binfo) "TITLE")
		     btitle)))
    (make entity
      system-id: "index.htm"
      (make document-type
	name: "HTML"
	public-id: %html-pubid%)
      (make element gi: "HTML"
	    (make element gi: "HEAD"
		  (make element gi: "TITLE"
			(with-mode admon-caption-mode
			  (process-node-list (node-list-first title)))))
	    (make element gi: "BODY" 
		  attributes: %body-attr%
		  (if (node-list-empty? binfo)
		      (make sequence
			(make element gi: "H1"
			      (if (node-list-empty? title)
				  (literal "Book")
				  (with-mode admon-caption-mode
				    (process-node-list 
				     (node-list-first title)))))
			(if (and %generate-toc% %generate-toc-in-front%)
			    (make sequence
			      (MAKETOC)
			      (process-children))
			    (make sequence
			      (process-children)
			      (if %generate-toc%
				  (MAKETOC)
				  (empty-sosofo)))))
		      (process-children)))))))

;; If the book title is present, then:
;;   If there's a BOOKINFO, we will have used that to make the title page,
;;      so ignore the BOOK TITLE
;;   Otherwise, generate a $divtitlepage$ with the BOOK TITLE
;;
(element (BOOK TITLE) (empty-sosofo))

(element (ARTHEADER TITLE) ($divtitlepage$))

(element (PART TITLE) ($divtitlepage$))

(element PARTINTRO ($section$))
(element (PARTINTRO TITLE) ($sectitle$))

