;; $Id: dblists.dsl 0.1 1997/07/31 14:51:33 nwalsh Exp $

;; =============================== LISTS ================================

(element ORDEREDLIST
  (let ((type (case (attribute-string "NUMERATION")
		(("UPPERALPHA") "A")
		(("LOWERALPHA") "a")
		(("UPPERROMAN") "I")
		(("LOWERROMAN") "i")
		(else "1"))))
    (make element gi: "OL"
	  attributes: (if (equal? (attribute-string "SPACING") "COMPACT")
			  (list
			   (list "COMPACT" "COMPACT")
			   (list "TYPE" type))
			  (list
			   (list "TYPE" type)))
	  (process-children))))
    
(element ITEMIZEDLIST
  (make element gi: "UL"
	attributes: (if (equal? (attribute-string "SPACING") "COMPACT")
			'(("COMPACT" "COMPACT"))
			'())
	(process-children)))

(element LISTITEM
  (make element gi: "LI"
	(process-children)))

(element VARIABLELIST
  (make element gi: "DL"
	(process-children)))

(element VARLISTENTRY
  (make element gi: "DT"
	(process-children)))

(element (VARLISTENTRY TERM)
  (make sequence
    (process-children-trim)
    (if (not (last-sibling?))
	(literal ", ")
	(literal ""))))

(element (VARLISTENTRY LISTITEM)
  (make element gi: "DD"
	(process-children)))

(element SIMPLELIST
  (let ((type (attribute-string "type")))
    (if (equal? type "INLINE")
	(process-children-trim)
	(process-children-trim))))

(element MEMBER
  (let ((type (inherited-attribute-string "type")))
    (if (equal? type "INLINE")
	(make sequence
	  (process-children-trim)
	  (if (not (last-sibling?))
	      (literal ", ")
	      (literal "")))
	(make sequence
	  (process-children-trim)
	  (if (not (last-sibling?))
	      (literal ", ")
	      (literal ""))))))

(element SEGMENTEDLIST (process-children))
(element (SEGMENTEDLIST TITLE) ($lowtitle$ 6))

(element SEGTITLE (empty-sosofo))

(mode seglist-in-seg
  (element SEGTITLE
    (make element gi: "B"
	  (process-children))))

(define (nth-node nl k)
  (if (equal? k 1)
      (node-list-first nl)
      (nth-node (node-list-rest nl) (- k 1))))

(element SEGLISTITEM ($paragraph$))
(element SEG 
  (let* ((seg-num (child-number (current-node)))
	 (seglist (parent (parent (current-node))))
	 (segtitle (nth-node (select-elements 
			 (descendants seglist) "SEGTITLE") seg-num)))

    ;; Note: segtitle is only going to be the right thing in a well formed
    ;; SegmentedList.  If there are too many Segs or too few SegTitles,
    ;; you'll get something odd...maybe an error

    (with-mode seglist-in-seg
      (make element gi: "P"
	    (make element gi: "B"
		  (sosofo-append (process-node-list segtitle))
		  (literal ": "))
	    (process-children)))))

;; To do:

(element CALLOUTLIST (process-children))
(element (CALLOUTLIST TITLE) ($lowtitle$ 2))
(element CALLOUT ($paragraph$))

